import { Record } from "immutable";
import { Result } from "../interfaces/result";
declare const ResultRecord_base: Record.Factory<Result<any>>;
declare class ResultRecord<T> extends ResultRecord_base implements Result<T> {
    constructor(params?: Result<T>);
    addError(key: string, message: string): ResultRecord<T>;
    addValidationError(key: string, message: string): ResultRecord<T>;
    errorCount(): number;
    hasErrorFor(key: string): boolean;
    hasErrors(): boolean;
    listErrors(): string[];
    listErrorMessages(): string[];
    with(values: Partial<Result<T>>): ResultRecord<T>;
    private _addErrorByType;
}
export { ResultRecord };
